-- ==========================================================================================================================
--   Various colors
-- ==========================================================================================================================

-- http://en.wikipedia.org/wiki/Web_colors

RMetColor =
	{
	-- Red colors
	INDIAN_RED             = {name="IndianRed",				label=L"Indian Red",				r=205,g=092,b=092,html="CD5C5C"},
	LIGHT_CORAL            = {name="LightCoral",			label=L"Light Coral",				r=240,g=128,b=128,html="F08080"},
	SALMON                 = {name="Salmon",				label=L"Salmon",					r=250,g=128,b=114,html="FA8072"},
	DARK_SALMON            = {name="DarkSalmon",			label=L"Dark Salmon",				r=233,g=150,b=122,html="E9967A"},
	LIGHT_SALMON           = {name="LightSalmon",			label=L"Light Salmon",				r=255,g=160,b=122,html="FFA07A"},
	CRIMSON                = {name="Crimson",				label=L"Crimson",					r=220,g=020,b=060,html="DC143C"},
	RED                    = {name="Red",					label=L"Red",						r=255,g=000,b=000,html="FF0000"},
	FIRE_BRICK             = {name="FireBrick",				label=L"Fire Brick",				r=178,g=034,b=034,html="B22222"},
	DARK_RED               = {name="DarkRed",				label=L"Dark Red",					r=139,g=000,b=000,html="8B0000"},
		
	-- Pink colors
	PINK                   = {name="Pink",					label=L"Pink",						r=255,g=192,b=203,html="FFC0CB"},
	LIGHT_PINK             = {name="LightPink",				label=L"Light Pink",				r=255,g=182,b=193,html="FFB6C1"},
	HOT_PINK               = {name="HotPink",				label=L"Hot Pink",					r=255,g=105,b=180,html="FF69B4"},
	DEEP_PINK              = {name="DeepPink",				label=L"Deep Pink",					r=255,g=020,b=147,html="FF1493"},
	MEDIUM_VIOLET_RED      = {name="MediumVioletRed",		label=L"Medium Violet Red",			r=199,g=021,b=133,html="C71585"},
	PALE_VIOLET_RED        = {name="PaleVioletRed",			label=L"Pale Violet Red",			r=219,g=112,b=147,html="DB7093"},
		
	-- Orange colors
	LIGHT_SALMON           = {name="LightSalmon",			label=L"Light Salmon",				r=255,g=160,b=122,html="FFA07A"},
	CORAL                  = {name="Coral",					label=L"Coral",						r=255,g=127,b=080,html="FF7F50"},
	TOMATO                 = {name="Tomato",				label=L"Tomato",					r=255,g=099,b=071,html="FF6347"},
	ORANGE_RED             = {name="OrangeRed",				label=L"Orange Red",				r=255,g=069,b=000,html="FF4500"},
	DARK_ORANGE            = {name="DarkOrange",			label=L"Dark Orange",				r=255,g=140,b=000,html="FF8C00"},
	ORANGE                 = {name="Orange",				label=L"Orange",					r=255,g=165,b=000,html="FFA500"},
		
	-- Yellow colors
	GOLD                   = {name="Gold",					label=L"Gold",						r=255,g=215,b=000,html="FFD700"},
	YELLOW                 = {name="Yellow",				label=L"Yellow",					r=255,g=255,b=000,html="FFFF00"},
	LIGHT_YELLOW           = {name="LightYellow",			label=L"Light Yellow",				r=255,g=255,b=224,html="FFFFE0"},
	LEMON_CHIFFON          = {name="LemonChiffon",			label=L"Lemon Chiffon",				r=255,g=250,b=205,html="FFFACD"},
	LIGHT_GOLDENROD_YELLOW = {name="LightGoldenrodYellow",	label=L"Light Goldenrod Yellow",	r=250,g=250,b=210,html="FAFAD2"},
	PAPAYA_WHIP            = {name="PapayaWhip",			label=L"Papaya Whip",				r=255,g=239,b=213,html="FFEFD5"},
	MOCCASIN               = {name="Moccasin",				label=L"Moccasin",					r=255,g=228,b=181,html="FFE4B5"},
	PEACH_PUFF             = {name="PeachPuff",				label=L"Peach Puff",				r=255,g=218,b=185,html="FFDAB9"},
	PALE_GOLDENROD         = {name="PaleGoldenrod",			label=L"Pale Goldenrod",			r=238,g=232,b=170,html="EEE8AA"},
	KHAKI                  = {name="Khaki",					label=L"Khaki",						r=240,g=230,b=140,html="F0E68C"},
	DARK_KHAKI             = {name="DarkKhaki",				label=L"Dark Khaki",				r=189,g=183,b=107,html="BDB76B"},
		
	-- Purple colors
	LAVENDER               = {name="Lavender",				label=L"Lavender",					r=230,g=230,b=250,html="E6E6FA"},
	THISTLE                = {name="Thistle",				label=L"Thistle",					r=216,g=191,b=216,html="D8BFD8"},
	PLUM                   = {name="Plum",					label=L"Plum",						r=221,g=160,b=221,html="DDA0DD"},
	VIOLET                 = {name="Violet",				label=L"Violet",					r=238,g=130,b=238,html="EE82EE"},
	ORCHID                 = {name="Orchid",				label=L"Orchid",					r=218,g=112,b=214,html="DA70D6"},
	FUCHSIA                = {name="Fuchsia",				label=L"Fuchsia",					r=255,g=000,b=255,html="FF00FF"},
	MAGENTA                = {name="Magenta",				label=L"Magenta",					r=255,g=000,b=255,html="FF00FF"},
	MEDIUM_ORCHID          = {name="MediumOrchid",			label=L"Medium Orchid",				r=186,g=085,b=211,html="BA55D3"},
	MEDIUM_PURPLE          = {name="MediumPurple",			label=L"Medium Purple",				r=147,g=112,b=219,html="9370DB"},
	BLUE_VIOLET            = {name="BlueViolet",			label=L"Blue Violet",				r=138,g=043,b=226,html="8A2BE2"},
	DARK_VIOLET            = {name="DarkViolet",			label=L"Dark Violet",				r=148,g=000,b=211,html="9400D3"},
	DARK_ORCHID            = {name="DarkOrchid",			label=L"Dark Orchid",				r=153,g=050,b=204,html="9932CC"},
	DARK_MAGENTA           = {name="DarkMagenta",			label=L"Dark Magenta",				r=139,g=000,b=139,html="8B008B"},
	PURPLE                 = {name="Purple",				label=L"Purple",					r=128,g=000,b=128,html="800080"},
	INDIGO                 = {name="Indigo",				label=L"Indigo",					r=075,g=000,b=130,html="4B0082"},
	SLATE_BLUE             = {name="SlateBlue",				label=L"Slate Blue",				r=106,g=090,b=205,html="6A5ACD"},
	DARK_SLATE_BLUE        = {name="DarkSlateBlue",			label=L"Dark Slate Blue",			r=072,g=061,b=139,html="483D8B"},
	MEDIUM_SLATE_BLUE      = {name="MediumSlateBlue",		label=L"Medium Slate Blue",			r=123,g=104,b=238,html="7B68EE"},
		
	-- Green colors
	GREEN_YELLOW           = {name="GreenYellow",			label=L"Green Yellow",				r=173,g=255,b=047,html="ADFF2F"},
	CHARTREUSE             = {name="Chartreuse",			label=L"Chartreuse",				r=127,g=255,b=000,html="7FFF00"},
	LAWN_GREEN             = {name="LawnGreen",				label=L"Lawn Green",				r=124,g=252,b=000,html="7CFC00"},
	LIME                   = {name="Lime",					label=L"Lime",						r=000,g=255,b=000,html="00FF00"},
	LIME_GREEN             = {name="LimeGreen",				label=L"Lime Green",				r=050,g=205,b=050,html="32CD32"},
	PALE_GREEN             = {name="PaleGreen",				label=L"Pale Green",				r=152,g=251,b=152,html="98FB98"},
	LIGHT_GREEN            = {name="LightGreen",			label=L"Light Green",				r=144,g=238,b=144,html="90EE90"},
	MEDIUM_SPRING_GREEN    = {name="MediumSpringGreen",		label=L"Medium Spring Green",		r=000,g=250,b=154,html="00FA9A"},
	SPRING_GREEN           = {name="SpringGreen",			label=L"Spring Green",				r=000,g=255,b=127,html="00FF7F"},
	MEDIUM_SEA_GREEN       = {name="MediumSeaGreen",		label=L"MediumSea Green",			r=060,g=179,b=113,html="3CB371"},
	SEA_GREEN              = {name="SeaGreen",				label=L"Sea Green",					r=046,g=139,b=087,html="2E8B57"},
	FOREST_GREEN           = {name="ForestGreen",			label=L"Forest Green",				r=034,g=139,b=034,html="228B22"},
	GREEN                  = {name="Green",					label=L"Green",						r=000,g=128,b=000,html="008000"},
	DARK_GREEN             = {name="DarkGreen",				label=L"Dark Green",				r=000,g=100,b=000,html="006400"},
	YELLOW_GREEN           = {name="YellowGreen",			label=L"Yellow Green",				r=154,g=205,b=050,html="9ACD32"},
	OLIVE_DRAB             = {name="OliveDrab",				label=L"Olive Drab",				r=107,g=142,b=035,html="6B8E23"},
	OLIVE                  = {name="Olive",					label=L"Olive",						r=128,g=128,b=000,html="808000"},
	DARK_OLIVE_GREEN       = {name="DarkOliveGreen",		label=L"Dark Olive Green",			r=085,g=107,b=047,html="556B2F"},
	MEDIUM_AQUAMARINE      = {name="MediumAquamarine",		label=L"Medium Aquamarine",			r=102,g=205,b=170,html="66CDAA"},
	DARK_SEA_GREEN         = {name="DarkSeaGreen",			label=L"Dark Sea Green",			r=143,g=188,b=143,html="8FBC8F"},
	LIGHT_SEA_GREEN        = {name="LightSeaGreen",			label=L"Light Sea Green",			r=032,g=178,b=170,html="20B2AA"},
	DARK_CYAN              = {name="DarkCyan",				label=L"Dark Cyan",					r=000,g=139,b=139,html="008B8B"},
	TEAL                   = {name="Teal",					label=L"Teal",						r=000,g=128,b=128,html="008080"},
		
	-- Blue colors
	AQUA                   = {name="Aqua",					label=L"Aqua",						r=000,g=255,b=255,html="00FFFF"},
	CYAN                   = {name="Cyan",					label=L"Cyan",						r=000,g=255,b=255,html="00FFFF"},
	LIGHT_CYAN             = {name="LightCyan",				label=L"Light Cyan",				r=224,g=255,b=255,html="E0FFFF"},
	PALE_TURQUOISE         = {name="PaleTurquoise",			label=L"Pale Turquoise",			r=175,g=238,b=238,html="AFEEEE"},
	AQUAMARINE             = {name="Aquamarine",			label=L"Aquamarine",				r=127,g=255,b=212,html="7FFFD4"},
	TURQUOISE              = {name="Turquoise",				label=L"Turquoise",					r=064,g=224,b=208,html="40E0D0"},
	MEDIUM_TURQUOISE       = {name="MediumTurquoise",		label=L"Medium Turquoise",			r=072,g=209,b=204,html="48D1CC"},
	DARK_TURQUOISE         = {name="DarkTurquoise",			label=L"Dark Turquoise",			r=000,g=206,b=209,html="00CED1"},
	CADET_BLUE             = {name="CadetBlue",				label=L"Cadet Blue",				r=095,g=158,b=160,html="5F9EA0"},
	STEEL_BLUE             = {name="SteelBlue",				label=L"Steel Blue",				r=070,g=130,b=180,html="4682B4"},
	LIGHT_STEEL_BLUE       = {name="LightSteelBlue",		label=L"Light Steel Blue",			r=176,g=196,b=222,html="B0C4DE"},
	POWDER_BLUE            = {name="PowderBlue",			label=L"Powder Blue",				r=176,g=224,b=230,html="B0E0E6"},
	LIGHT_BLUE             = {name="LightBlue",				label=L"Light Blue",				r=173,g=216,b=230,html="ADD8E6"},
	SKY_BLUE               = {name="SkyBlue",				label=L"Sky Blue",					r=135,g=206,b=235,html="87CEEB"},
	LIGHT_SKY_BLUE         = {name="LightSkyBlue",			label=L"Light Sky Blue",			r=135,g=206,b=250,html="87CEFA"},
	DEEP_SKY_BLUE          = {name="DeepSkyBlue",			label=L"Deep Sky Blue",				r=000,g=191,b=255,html="00BFFF"},
	DODGER_BLUE            = {name="DodgerBlue",			label=L"Dodger Blue",				r=030,g=144,b=255,html="1E90FF"},
	CORNFLOWER_BLUE        = {name="CornflowerBlue",		label=L"Cornflower Blue",			r=100,g=149,b=237,html="6495ED"},
	MEDIUM_SLATE_BLUE      = {name="MediumSlateBlue",		label=L"Medium Slate Blue",			r=123,g=104,b=238,html="7B68EE"},
	ROYAL_BLUE             = {name="RoyalBlue",				label=L"Royal Blue",				r=065,g=105,b=225,html="4169E1"},
	BLUE                   = {name="Blue",					label=L"Blue",						r=000,g=000,b=255,html="0000FF"},
	MEDIUM_BLUE            = {name="MediumBlue",			label=L"Medium Blue",				r=000,g=000,b=205,html="0000CD"},
	DARK_BLUE              = {name="DarkBlue",				label=L"Dark Blue",					r=000,g=000,b=139,html="00008B"},
	NAVY                   = {name="Navy",					label=L"Navy",						r=000,g=000,b=128,html="000080"},
	MIDNIGHT_BLUE          = {name="MidnightBlue",			label=L"Midnight Blue",				r=025,g=025,b=112,html="191970"},
		
	-- Brown colors
	CORNSILK               = {name="Cornsilk",				label=L"Cornsilk",					r=255,g=248,b=220,html="FFF8DC"},
	BLANCHED_ALMOND        = {name="BlanchedAlmond",		label=L"Blanched Almond",			r=255,g=235,b=205,html="FFEBCD"},
	BISQUE                 = {name="Bisque",				label=L"Bisque",					r=255,g=228,b=196,html="FFE4C4"},
	NAVAJO_WHITE           = {name="NavajoWhite",			label=L"Navajo White",				r=255,g=222,b=173,html="FFDEAD"},
	WHEAT                  = {name="Wheat",					label=L"Wheat",						r=245,g=222,b=179,html="F5DEB3"},
	BURLY_WOOD             = {name="BurlyWood",				label=L"Burly Wood",				r=222,g=184,b=135,html="DEB887"},
	TAN                    = {name="Tan",					label=L"Tan",						r=210,g=180,b=140,html="D2B48C"},
	ROSY_BROWN             = {name="RosyBrown",				label=L"Rosy Brown",				r=188,g=143,b=143,html="BC8F8F"},
	SANDY_BROWN            = {name="SandyBrown",			label=L"Sandy Brown",				r=244,g=164,b=096,html="F4A460"},
	GOLDENROD              = {name="Goldenrod",				label=L"Goldenrod",					r=218,g=165,b=032,html="DAA520"},
	DARK_GOLDENROD         = {name="DarkGoldenrod",			label=L"Dark Goldenrod",			r=184,g=134,b=011,html="B8860B"},
	PERU                   = {name="Peru",					label=L"Peru",						r=205,g=133,b=063,html="CD853F"},
	CHOCOLATE              = {name="Chocolate",				label=L"Chocolate",					r=210,g=105,b=030,html="D2691E"},
	SADDLE_BROWN           = {name="SaddleBrown",			label=L"Saddle Brown",				r=139,g=069,b=019,html="8B4513"},
	SIENNA                 = {name="Sienna",				label=L"Sienna",					r=160,g=082,b=045,html="A0522D"},
	BROWN                  = {name="Brown",					label=L"Brown",						r=165,g=042,b=042,html="A52A2A"},
	MAROON                 = {name="Maroon",				label=L"Maroon",					r=128,g=000,b=000,html="800000"},
		
	-- White colors
	WHITE                  = {name="White",					label=L"White",						r=255,g=255,b=255,html="FFFFFF"},
	SNOW                   = {name="Snow",					label=L"Snow",						r=255,g=250,b=250,html="FFFAFA"},
	HONEYDEW               = {name="Honeydew",				label=L"Honeydew",					r=240,g=255,b=240,html="F0FFF0"},
	MINT_CREAM             = {name="MintCream",				label=L"Mint Cream",				r=245,g=255,b=250,html="F5FFFA"},
	AZURE                  = {name="Azure",					label=L"Azure",						r=240,g=255,b=255,html="F0FFFF"},
	ALICE_BLUE             = {name="AliceBlue",				label=L"Alice Blue",				r=240,g=248,b=255,html="F0F8FF"},
	GHOST_WHITE            = {name="GhostWhite",			label=L"Ghost White",				r=248,g=248,b=255,html="F8F8FF"},
	WHITE_SMOKE            = {name="WhiteSmoke",			label=L"White Smoke",				r=245,g=245,b=245,html="F5F5F5"},
	SEASHELL               = {name="Seashell",				label=L"Seashell",					r=255,g=245,b=238,html="FFF5EE"},
	BEIGE                  = {name="Beige",					label=L"Beige",						r=245,g=245,b=220,html="F5F5DC"},
	OLD_LACE               = {name="OldLace",				label=L"Old Lace",					r=253,g=245,b=230,html="FDF5E6"},
	FLORAL_WHITE           = {name="FloralWhite",			label=L"Floral White",				r=255,g=250,b=240,html="FFFAF0"},
	IVORY                  = {name="Ivory",					label=L"Ivory",						r=255,g=255,b=240,html="FFFFF0"},
	ANTIQUE_WHITE          = {name="AntiqueWhite",			label=L"Antique White",				r=250,g=235,b=215,html="FAEBD7"},
	LINEN                  = {name="Linen",					label=L"Linen",						r=250,g=240,b=230,html="FAF0E6"},
	LAVENDER_BLUSH         = {name="LavenderBlush",			label=L"Lavender Blush",			r=255,g=240,b=245,html="FFF0F5"},
	MISTY_ROSE             = {name="MistyRose",				label=L"Misty Rose",				r=255,g=228,b=225,html="FFE4E1"},
		
	-- Grey colors
	GAINSBORO              = {name="Gainsboro",				label=L"Gainsboro",					r=220,g=220,b=220,html="DCDCDC"},
	LIGHT_GREY             = {name="LightGrey",				label=L"Light Grey",				r=211,g=211,b=211,html="D3D3D3"},
	SILVER                 = {name="Silver",				label=L"Silver",					r=192,g=192,b=192,html="C0C0C0"},
	DARK_GRAY              = {name="DarkGray",				label=L"Dark Gray",					r=169,g=169,b=169,html="A9A9A9"},
	GRAY                   = {name="Gray",					label=L"Gray",						r=128,g=128,b=128,html="808080"},
	DIM_GRAY               = {name="DimGray",				label=L"Dim Gray",					r=105,g=105,b=105,html="696969"},
	LIGHT_SLATE_GRAY       = {name="LightSlateGray",		label=L"Light Slate Gray",			r=119,g=136,b=153,html="778899"},
	SLATE_GRAY             = {name="SlateGray",				label=L"Slate Gray",				r=112,g=128,b=144,html="708090"},
	DARK_SLATE_GRAY        = {name="DarkSlateGray",			label=L"Dark Slate Gray",			r=047,g=079,b=079,html="2F4F4F"},
	BLACK                  = {name="Black",					label=L"Black",						r=000,g=000,b=000,html="000000"},

	-- self defined
    GRAY80                 = {name='Gray80',				label=L"Gray 80%",					r=051,g=051,b=051,html='333333'},

};

RMetColorGroups =
	{
		[1] = {	label		= "Red colors",
				labelColor	= 'RED',
				colors		= {	'INDIAN_RED', 'LIGHT_CORAL', 'SALMON', 'DARK_SALMON', 'LIGHT_SALMON', 'CRIMSON', 'RED', 'FIRE_BRICK', 'DARK_RED',
								},
				},
		[2] = {	label		= "Pink colors",
				labelColor	= 'PINK',
				colors		= { 'PINK', 'LIGHT_PINK', 'HOT_PINK', 'DEEP_PINK', 'MEDIUM_VIOLET_RED', 'PALE_VIOLET_RED',
								},
				},
		
		[3] = {	label		= "Orange colors",
				labelColor	= 'ORANGE',
				colors		= { 'LIGHT_SALMON', 'CORAL', 'TOMATO', 'ORANGE_RED', 'DARK_ORANGE', 'ORANGE',
								},
				},
		
		[4] = {	label		= "Yellow colors",
				labelColor	= 'YELLOW',
				colors		= { 'GOLD', 'YELLOW', 'LIGHT_YELLOW', 'LEMON_CHIFFON', 'LIGHT_GOLDENROD_YELLOW', 'PAPAYA_WHIP', 'MOCCASIN', 'PEACH_PUFF', 'PALE_GOLDENROD', 
								'KHAKI', 'DARK_KHAKI',
								},
				},
		
		[5] = {	label		= "Purple colors",
				labelColor	= 'PURPLE',
				colors		= { 'LAVENDER', 'THISTLE', 'PLUM', 'VIOLET', 'ORCHID', 'FUCHSIA', 'MAGENTA', 'MEDIUM_ORCHID', 'MEDIUM_PURPLE', 'BLUE_VIOLET', 'DARK_VIOLET',
								'DARK_ORCHID', 'DARK_MAGENTA', 'PURPLE', 'INDIGO', 'SLATE_BLUE', 'DARK_SLATE_BLUE', 'MEDIUM_SLATE_BLUE',
								},
				},
		
		[6] = {	label		= "Gree colors",
				labelColor	= 'GREEN',
				colors		= { 'GREEN_YELLOW', 'CHARTREUSE', 'LAWN_GREEN', 'LIME', 'LIME_GREEN', 'PALE_GREEN', 'LIGHT_GREEN', 'MEDIUM_SPRING_GREEN', 'SPRING_GREEN',
								'MEDIUM_SEA_GREEN', 'SEA_GREEN', 'FOREST_GREEN', 'GREEN', 'DARK_GREEN', 'YELLOW_GREEN', 'OLIVE_DRAB', 'OLIVE', 'DARK_OLIVE_GREEN',
								'MEDIUM_AQUAMARINE', 'DARK_SEA_GREEN', 'LIGHT_SEA_GREEN', 'DARK_CYAN', 'TEAL',
								},
				},
		
		[7] = {	label		= "Blue colors",
				labelColor	= 'BLUE',
				colors		= { 'AQUA', 'CYAN', 'LIGHT_CYAN', 'PALE_TURQUOISE', 'AQUAMARINE', 'TURQUOISE', 'MEDIUM_TURQUOISE', 'DARK_TURQUOISE', 'CADET_BLUE', 'STEEL_BLUE',
								'LIGHT_STEEL_BLUE', 'POWDER_BLUE', 'LIGHT_BLUE', 'SKY_BLUE', 'LIGHT_SKY_BLUE', 'DEEP_SKY_BLUE', 'DODGER_BLUE', 'CORNFLOWER_BLUE',
								'MEDIUM_SLATE_BLUE', 'ROYAL_BLUE', 'BLUE', 'MEDIUM_BLUE', 'DARK_BLUE', 'NAVY', 'MIDNIGHT_BLUE',
								},
				},
		
		[8] = {	label		= "Brown colors",
				labelColor	= 'BROWN',
				colors		= { 'CORNSILK', 'BLANCHED_ALMOND', 'BISQUE', 'NAVAJO_WHITE', 'WHEAT', 'BURLY_WOOD', 'TAN', 'ROSY_BROWN', 'SANDY_BROWN', 'GOLDENROD', 'DARK_GOLDENROD',
								'PERU', 'CHOCOLATE', 'SADDLE_BROWN', 'SIENNA', 'BROWN', 'MAROON',
								},
				},
		
		[9] = {	label		= "White colors",
				labelColor	= 'WHITE',
				colors		= { 'WHITE', 'SNOW', 'HONEYDEW', 'MINT_CREAM', 'AZURE', 'ALICE_BLUE', 'GHOST_WHITE', 'WHITE_SMOKE', 'SEASHELL', 'BEIGE', 'OLD_LACE', 'FLORAL_WHITE',
								'IVORY', 'ANTIQUE_WHITE', 'LINEN', 'LAVENDER_BLUSH', 'MISTY_ROSE',
								},
				},
		
		[10]= {	label		= "Gray colors",
				labelColor	= 'GRAY',
				colors		= { 'GAINSBORO', 'LIGHT_GREY', 'SILVER', 'DARK_GRAY', 'GRAY', 'DIM_GRAY', 'LIGHT_SLATE_GRAY', 'SLATE_GRAY', 'DARK_SLATE_GRAY', 'BLACK',
								},
				},


};
