HealGridSkinBase = {

	skin = {
		id = "HEALGRID_BASE",
		name = L"HealGrid - Base",
		author = "rmet0815",
		sortCriteria = "__HG_BASE",
	},

	hud = {
		buffs = {
			size = 28,
			border = 1,
			textPadding = 1,
			font = "font_clear_small_bold",
		},
		unitFrame = {
			width = 60,
			height = 60,
			borderWidth = 2,
			borderHeight = 2,
			background = {
				color = "HEALTHCOLOR",
				texture = "WARTintSquare",
				style = "TILE",
			},
			careerLineIcon = {
				scale = 80,
				alpha = 50,
				position = 'CENTER',
				paddingX = "0",
				paddingY = "0",
				isVisible = true,
			},
			healthPointsBar = {
				anchor1 = { windowName="SELF", point="TOPLEFT", relativeTo="PARENT", relativePoint="TOPLEFT", offsetX="0", offsetY="0", },
				anchor2 = { windowName="SELF", point="BOTTOMRIGHT", relativeTo="PARENT", relativePoint="BOTTOMRIGHT", offsetX="0", offsetY="0", },
				growth = "BOTTOM_TOP",
				foreground = {
					isVisible = true,
					color = "GREEN",
					texture = "WARTintSquare",
					style = "TILE",
				},
				background = {
					isVisible = true,
					color = "BLACK",
					texture = "WARTintSquare",
					style = "TILE",
				},
				isToggleable = true,
				isVisible = false,
			},
			actionPointsBar = {
				anchor1 = { windowName="SELF", point="TOPRIGHT", relativeTo="PARENT", relativePoint="TOPLEFT", offsetX="-10%", offsetY="0", },
				anchor2 = { windowName="SELF", point="BOTTOMRIGHT", relativeTo="PARENT", relativePoint="BOTTOMRIGHT", offsetX="0", offsetY="0", },
				growth = "BOTTOM_TOP",
				foreground = {
					isVisible = true,
					color = "ROYAL_BLUE",
					texture = "WARTintSquare",
					style = "TILE",
				},
				background = {
					isVisible = false,
					color = "BLACK",
					texture = "WARTintSquare",
					style = "TILE",
				},
				isToggleable = true,
				isVisible = false,
			},
			moraleLevelBar = {
				anchor1 = { windowName="SELF", point="TOPLEFT", relativeTo="PARENT", relativePoint="TOPLEFT", offsetX="0", offsetY="0", },
				anchor2 = { windowName="SELF", point="BOTTOMLEFT", relativeTo="PARENT", relativePoint="BOTTOMRIGHT", offsetX="10%", offsetY="0", },
				growth = "BOTTOM_TOP",
				foreground = {
					isVisible = true,
					color = "DARK_SLATE_GRAY",
					texture = "WARTintSquare",
					style = "TILE",
				},
				background = {
					isVisible = false,
					color = "BLACK",
					texture = "WARTintSquare",
					style = "TILE",
				},
				isToggleable = true,
				isVisible = false,
			},
		},
		avatarFrame = {
			spellTrack1 = {
				font = "font_clear_small",
				position = 'TOPLEFT',
				maxWidth = 100,
			},
			spellTrack2 = {
				font = "font_clear_small",
				position = 'LEFT',
				maxWidth = 40,
			},
			labelTopLeft = {
				label = L"",
				font = "font_clear_small",
				paddingX = "0",
				paddingY = "0",
				color = 'WHITE',
				isTargeted = false,
				inAvatarGroup = false,
			},
			labelTop = {
				label = L"",
				font = "font_clear_small",
				paddingX = "0",
				paddingY = "0",
				color = 'WHITE',
				isTargeted = false,
				inAvatarGroup = false,
			},
			labelTopRight = {
				label = L"",
				font = "font_clear_small",
				paddingX = "0",
				paddingY = "0",
				color = 'WHITE',
				isTargeted = false,
				inAvatarGroup = false,
			},
			labelLeft = {
				label = L"",
				font = "font_clear_small",
				paddingX = "0",
				paddingY = "0",
				color = 'WHITE',
				isTargeted = false,
				inAvatarGroup = false,
			},
			labelCenter = {
				label = L"[hpperc]",
				font = "font_clear_medium_bold",
				paddingX = "0",
				paddingY = "0",
				color = 'WHITE',
				isTargeted = false,
				inAvatarGroup = false,
			},
			labelRight = {
				label = L"",
				font = "font_clear_small",
				paddingX = "0",
				paddingY = "0",
				color = 'WHITE',
				isTargeted = false,
				inAvatarGroup = false,
			},
			labelBottomLeft = {
				label = L"",
				font = "font_clear_small",
				paddingX = "0",
				paddingY = "0",
				color = 'WHITE',
				isTargeted = false,
				inAvatarGroup = false,
			},
			labelBottom = {
				label = L"",
				font = "font_clear_small",
				paddingX = "0",
				paddingY = "0",
				color = 'WHITE',
				isTargeted = false,
				inAvatarGroup = false,
			},
			labelBottomRight = {
				label = L"",
				font = "font_clear_small",
				paddingX = "0",
				paddingY = "0",
				color = 'WHITE',
				isTargeted = false,
				inAvatarGroup = false,
			},
		},
		petFrame = {
			spellTrack1 = {
				font = "font_clear_small",
				position = 'TOPLEFT',
				maxWidth = 100,
			},
			spellTrack2 = {
				font = "font_clear_small",
				position = 'LEFT',
				maxWidth = 40,
			},
			labelTopLeft = {
				label = L"",
				font = "font_clear_small",
				paddingX = "0",
				paddingY = "0",
				color = 'WHITE',
				isTargeted = false,
				inAvatarGroup = false,
			},
			labelTop = {
				label = L"",
				font = "font_clear_small",
				paddingX = "0",
				paddingY = "0",
				color = 'WHITE',
				isTargeted = false,
				inAvatarGroup = false,
			},
			labelTopRight = {
				label = L"",
				font = "font_clear_small",
				paddingX = "0",
				paddingY = "0",
				color = 'WHITE',
				isTargeted = false,
				inAvatarGroup = false,
			},
			labelLeft = {
				label = L"",
				font = "font_clear_small",
				paddingX = "0",
				paddingY = "0",
				color = 'WHITE',
				isTargeted = false,
				inAvatarGroup = false,
			},
			labelCenter = {
				label = L"[hpperc]",
				font = "font_clear_medium_bold",
				paddingX = "0",
				paddingY = "0",
				color = 'WHITE',
				isTargeted = false,
				inAvatarGroup = false,
			},
			labelRight = {
				label = L"",
				font = "font_clear_small",
				paddingX = "0",
				paddingY = "0",
				color = 'WHITE',
				isTargeted = false,
				inAvatarGroup = false,
			},
			labelBottomLeft = {
				label = L"",
				font = "font_clear_small",
				paddingX = "0",
				paddingY = "0",
				color = 'WHITE',
				isTargeted = false,
				inAvatarGroup = false,
			},
			labelBottom = {
				label = L"",
				font = "font_clear_small",
				paddingX = "0",
				paddingY = "0",
				color = 'WHITE',
				isTargeted = false,
				inAvatarGroup = false,
			},
			labelBottomRight = {
				label = L"[stance:len=1,upper]",
				font = "font_clear_small",
				paddingX = "0",
				paddingY = "0",
				color = 'WHITE',
				isTargeted = false,
				inAvatarGroup = false,
			},
		},
		friendlyTargetFrame = {
			spellTrack1 = {
				font = "font_clear_small",
				position = 'TOPLEFT',
				maxWidth = 100,
			},
			spellTrack2 = {
				font = "font_clear_small",
				position = 'LEFT',
				maxWidth = 40,
			},
			labelTopLeft = {
				label = L"",
				font = "font_clear_small",
				paddingX = "0",
				paddingY = "0",
				color = 'WHITE',
				isTargeted = false,
				inAvatarGroup = false,
			},
			labelTop = {
				label = L"",
				font = "font_clear_small",
				paddingX = "0",
				paddingY = "0",
				color = 'WHITE',
				isTargeted = false,
				inAvatarGroup = false,
			},
			labelTopRight = {
				label = L"",
				font = "font_clear_small",
				paddingX = "0",
				paddingY = "0",
				color = 'WHITE',
				isTargeted = false,
				inAvatarGroup = false,
			},
			labelLeft = {
				label = L"",
				font = "font_clear_small",
				paddingX = "0",
				paddingY = "0",
				color = 'WHITE',
				isTargeted = false,
				inAvatarGroup = false,
			},
			labelCenter = {
				label = L"[hpperc]",
				font = "font_clear_medium_bold",
				paddingX = "0",
				paddingY = "0",
				color = 'WHITE',
				isTargeted = false,
				inAvatarGroup = false,
			},
			labelRight = {
				label = L"",
				font = "font_clear_small",
				paddingX = "0",
				paddingY = "0",
				color = 'WHITE',
				isTargeted = false,
				inAvatarGroup = false,
			},
			labelBottomLeft = {
				label = L"[name]",
				font = "font_clear_small",
				paddingX = "0",
				paddingY = "0",
				color = 'CLASSCOLOR',
				isTargeted = false,
				inAvatarGroup = false,
			},
			labelBottom = {
				label = L"",
				font = "font_clear_small",
				paddingX = "0",
				paddingY = "0",
				color = 'WHITE',
				isTargeted = false,
				inAvatarGroup = false,
			},
			labelBottomRight = {
				label = L"",
				font = "font_clear_small",
				paddingX = "0",
				paddingY = "0",
				color = 'WHITE',
				isTargeted = false,
				inAvatarGroup = false,
			},
		},
		hostileTargetFrame = {
			spellTrack1 = {
				font = "font_clear_small",
				position = 'TOPLEFT',
				maxWidth = 100,
			},
			spellTrack2 = {
				font = "font_clear_small",
				position = 'LEFT',
				maxWidth = 40,
			},
			labelTopLeft = {
				label = L"",
				font = "font_clear_small",
				paddingX = "0",
				paddingY = "0",
				color = 'WHITE',
				isTargeted = false,
				inAvatarGroup = false,
			},
			labelTop = {
				label = L"",
				font = "font_clear_small",
				paddingX = "0",
				paddingY = "0",
				color = 'WHITE',
				isTargeted = false,
				inAvatarGroup = false,
			},
			labelTopRight = {
				label = L"",
				font = "font_clear_small",
				paddingX = "0",
				paddingY = "0",
				color = 'WHITE',
				isTargeted = false,
				inAvatarGroup = false,
			},
			labelLeft = {
				label = L"",
				font = "font_clear_small",
				paddingX = "0",
				paddingY = "0",
				color = 'WHITE',
				isTargeted = false,
				inAvatarGroup = false,
			},
			labelCenter = {
				label = L"[hpperc]",
				font = "font_clear_medium_bold",
				paddingX = "0",
				paddingY = "0",
				color = 'WHITE',
				isTargeted = false,
				inAvatarGroup = false,
			},
			labelRight = {
				label = L"",
				font = "font_clear_small",
				paddingX = "0",
				paddingY = "0",
				color = 'WHITE',
				isTargeted = false,
				inAvatarGroup = false,
			},
			labelBottomLeft = {
				label = L"",
				font = "font_clear_small",
				paddingX = "0",
				paddingY = "0",
				color = 'WHITE',
				isTargeted = false,
				inAvatarGroup = false,
			},
			labelBottom = {
				label = L"",
				font = "font_clear_small",
				paddingX = "0",
				paddingY = "0",
				color = 'WHITE',
				isTargeted = false,
				inAvatarGroup = false,
			},
			labelBottomRight = {
				label = L"[leveldiff][tiersign]",
				font = "font_clear_small",
				paddingX = "0",
				paddingY = "0",
				color = 'CONCOLOR',
				isTargeted = false,
				inAvatarGroup = false,
			},
		},
		petTargetFrame = {
			spellTrack1 = {
				font = "font_clear_small",
				position = 'TOPLEFT',
				maxWidth = 100,
			},
			spellTrack2 = {
				font = "font_clear_small",
				position = 'LEFT',
				maxWidth = 40,
			},
			labelTopLeft = {
				label = L"",
				font = "font_clear_small",
				paddingX = "0",
				paddingY = "0",
				color = 'WHITE',
				isTargeted = false,
				inAvatarGroup = false,
			},
			labelTop = {
				label = L"",
				font = "font_clear_small",
				paddingX = "0",
				paddingY = "0",
				color = 'WHITE',
				isTargeted = false,
				inAvatarGroup = false,
			},
			labelTopRight = {
				label = L"",
				font = "font_clear_small",
				paddingX = "0",
				paddingY = "0",
				color = 'WHITE',
				isTargeted = false,
				inAvatarGroup = false,
			},
			labelLeft = {
				label = L"",
				font = "font_clear_small",
				paddingX = "0",
				paddingY = "0",
				color = 'WHITE',
				isTargeted = false,
				inAvatarGroup = false,
			},
			labelCenter = {
				label = L"[hpperc]",
				font = "font_clear_medium_bold",
				paddingX = "0",
				paddingY = "0",
				color = 'WHITE',
				isTargeted = false,
				inAvatarGroup = false,
			},
			labelRight = {
				label = L"",
				font = "font_clear_small",
				paddingX = "0",
				paddingY = "0",
				color = 'WHITE',
				isTargeted = false,
				inAvatarGroup = false,
			},
			labelBottomLeft = {
				label = L"[name]",
				font = "font_clear_small",
				paddingX = "0",
				paddingY = "0",
				color = 'WHITE',
				isTargeted = false,
				inAvatarGroup = false,
			},
			labelBottom = {
				label = L"",
				font = "font_clear_small",
				paddingX = "0",
				paddingY = "0",
				color = 'WHITE',
				isTargeted = false,
				inAvatarGroup = false,
			},
			labelBottomRight = {
				label = L"",
				font = "font_clear_small",
				paddingX = "0",
				paddingY = "0",
				color = 'WHITE',
				isTargeted = false,
				inAvatarGroup = false,
			},
		},
		actionPointFrame = {
			height = 16,
			border = {
				width = 1,
				height = 1,
				color = 'BLACK',
			},
			foreground = {
				color = { r=71, g=132, b=214 },
				texture = "WARTintSquare",
				style = "TILE",
			},
			background = {
				color = 'GRAY80',
				texture = "WARTintSquare",
				style = "TILE",
			},
			labelLeft = {
				label = L"",
				font = "font_clear_tiny",
				color = "WHITE",
			},
			labelCenter = {
				label = L"[ap]",
				font = "font_clear_tiny",
				color = "WHITE",
			},
			labelRight = {
				label = L"",
				font = "font_clear_tiny",
				color = "WHITE",
			},
		},
		careerFrame = {
			height = 16,
			border = {
				width = 1,
				height = 1,
				color = 'BLACK',
			},
			foreground = {
				color = { r=255, g=0, b=255 },
				texture = "WARTintSquare",
				style = "TILE",
			},
			background = {
				color = 'GRAY80',
				texture = "WARTintSquare",
				style = "TILE",
			},
			labelLeft = {
				label = L"",
				font = "font_clear_tiny",
				color = "WHITE",
			},
			labelCenter = {
				label = L"[cp]",
				font = "font_clear_tiny",
				color = "WHITE",
			},
			labelRight = {
				label = L"",
				font = "font_clear_tiny",
				color = "WHITE",
			},
		},
		moraleFrame = {
			height = 16,
			border = {
				width = 1,
				height = 1,
				color = 'BLACK',
			},
			foreground = {
				color = { r=8, g=68, b=90 },
				texture = "WARTintSquare",
				style = "TILE",
			},
			background = {
				color = 'GRAY80',
				texture = "WARTintSquare",
				style = "TILE",
			},
			labelLeft = {
				label = L"",
				font = "font_alert_outline_half_small",
				color = "WHITE",
			},
			labelCenter = {
				label = L"[mlx]",
				font = "font_alert_outline_half_small",
				color = "MCDCOLOR",
			},
			labelRight = {
				label = L"",
				font = "font_alert_outline_half_small",
				color = "WHITE",
			},
		},
		castFrame = {
			height = 16,
			border = {
				width = 1,
				height = 1,
				color = 'BLACK',
			},
			foreground = {
				color = { r=255, g=210, b=0 },
				channelColor = { r=173, g=255, b=47 },
				failureColor = { r=178, g=34, b=34 },
				globalCooldownColor = { r=210, g=105, b=30 },
				texture = "WARTintSquare",
				style = "TILE",
			},
			background = {
				color = 'GRAY80',
				texture = "WARTintSquare",
				style = "TILE",
			},
			labelLeft = {
				font = "font_clear_tiny",
			},
			labelCenter = {
				font = "font_clear_tiny",
			},
			labelRight = {
				font = "font_clear_tiny",
			},
		},
		target = {
			font = "font_clear_medium_bold",
		},
	},

	grid = {
		grouping = 'GROUP',
		orientation = 'HORIZONTAL',
		growth = 'DOWN',
		unitFrame = {
			width = 60,
			height = 60,
			borderWidth = 2,
			borderHeight = 2,
			background = {
				color = "HEALTHCOLOR",
				texture = "WARTintSquare",
				style = "TILE",
			},
			careerLineIcon = {
				scale = 80,
				alpha = 50,
				position = 'CENTER',
				paddingX = "0",
				paddingY = "0",
				isVisible = true,
			},
			healthPointsBar = {
				anchor1 = { windowName="SELF", point="TOPLEFT", relativeTo="PARENT", relativePoint="TOPLEFT", offsetX="0", offsetY="0", },
				anchor2 = { windowName="SELF", point="BOTTOMRIGHT", relativeTo="PARENT", relativePoint="BOTTOMRIGHT", offsetX="0", offsetY="0", },
				growth = "BOTTOM_TOP",
				foreground = {
					isVisible = true,
					color = "GREEN",
					texture = "WARTintSquare",
					style = "TILE",
				},
				background = {
					isVisible = true,
					color = "BLACK",
					texture = "WARTintSquare",
					style = "TILE",
				},
				isToggleable = true,
				isVisible = false,
			},
			actionPointsBar = {
				anchor1 = { windowName="SELF", point="TOPRIGHT", relativeTo="PARENT", relativePoint="TOPLEFT", offsetX="-10%", offsetY="0", },
				anchor2 = { windowName="SELF", point="BOTTOMRIGHT", relativeTo="PARENT", relativePoint="BOTTOMRIGHT", offsetX="0", offsetY="0", },
				growth = "BOTTOM_TOP",
				foreground = {
					isVisible = true,
					color = "ROYAL_BLUE",
					texture = "WARTintSquare",
					style = "TILE",
				},
				background = {
					isVisible = false,
					color = "BLACK",
					texture = "WARTintSquare",
					style = "TILE",
				},
				isToggleable = true,
				isVisible = false,
			},
			moraleLevelBar = {
				anchor1 = { windowName="SELF", point="TOPLEFT", relativeTo="PARENT", relativePoint="TOPLEFT", offsetX="0", offsetY="0", },
				anchor2 = { windowName="SELF", point="BOTTOMLEFT", relativeTo="PARENT", relativePoint="BOTTOMRIGHT", offsetX="10%", offsetY="0", },
				growth = "BOTTOM_TOP",
				foreground = {
					isVisible = true,
					color = "DARK_SLATE_GRAY",
					texture = "WARTintSquare",
					style = "TILE",
				},
				background = {
					isVisible = false,
					color = "BLACK",
					texture = "WARTintSquare",
					style = "TILE",
				},
				isToggleable = true,
				isVisible = false,
			},
			spellTrack1 = {
				font = "font_clear_small",
				position = 'TOPLEFT',
				maxWidth = 100,
			},
			spellTrack2 = {
				font = "font_clear_small",
				position = 'LEFT',
				maxWidth = 40,
			},
			labelTopLeft = {
				label = L"",
				font = "font_clear_small",
				paddingX = "0",
				paddingY = "0",
				color = 'WHITE',
				isTargeted = false,
				inAvatarGroup = false,
			},
			labelTop = {
				label = L"",
				font = "font_clear_small",
				paddingX = "0",
				paddingY = "0",
				color = 'WHITE',
				isTargeted = false,
				inAvatarGroup = false,
			},
			labelTopRight = {
				label = L"",
				font = "font_clear_small",
				paddingX = "0",
				paddingY = "0",
				color = 'WHITE',
				isTargeted = false,
				inAvatarGroup = false,
			},
			labelLeft = {
				label = L"",
				font = "font_clear_small",
				paddingX = "0",
				paddingY = "0",
				color = 'WHITE',
				isTargeted = false,
				inAvatarGroup = false,
			},
			labelCenter = {
				label = L"[hpperc]",
				font = "font_clear_medium_bold",
				paddingX = "0",
				paddingY = "0",
				color = 'WHITE',
				isTargeted = true,
				inAvatarGroup = true,
			},
			labelRight = {
				label = L"",
				font = "font_clear_small",
				paddingX = "0",
				paddingY = "0",
				color = 'WHITE',
				isTargeted = false,
				inAvatarGroup = false,
			},
			labelBottomLeft = {
				label = L"[groupleader:post=:][mainassist:post=:][name]",
				font = "font_clear_small",
				paddingX = "0",
				paddingY = "0",
				color = 'CLASSCOLOR',
				isTargeted = false,
				inAvatarGroup = false,
			},
			labelBottom = {
				label = L"",
				font = "font_clear_small",
				paddingX = "0",
				paddingY = "0",
				color = 'WHITE',
				isTargeted = false,
				inAvatarGroup = false,
			},
			labelBottomRight = {
				label = L"",
				font = "font_clear_small",
				paddingX = "0",
				paddingY = "0",
				color = 'WHITE',
				isTargeted = false,
				inAvatarGroup = false,
			},
		},
		petFrame = {
			height = 20,
			borderWidth = 2,
			borderHeight = 2,
			labelCenter = {
				font = "font_clear_small_bold",
			},
		},
	},

};

HealGridSkin.RegisterSkin( HealGridSkinBase, nil );
